每日OJ题_算法_滑动窗口②_力扣3. 无重复字符的最长子串

力扣3. 无重复字符的最长子串

难度 中等

给定一个字符串 s ,请你找出其中不含有重复字符的 最长子串的长度。

示例 1:

复制代码
输入: s = "abcabcbb"
输出: 3 
解释: 因为无重复字符的最长子串是 "abc",所以其长度为 3。

示例 2:

复制代码
输入: s = "bbbbb"
输出: 1
解释: 因为无重复字符的最长子串是 "b",所以其长度为 1。

示例 3:

复制代码
输入: s = "pwwkew"
输出: 3
解释: 因为无重复字符的最长子串是 "wke",所以其长度为 3。     请注意,你的答案必须是 子串 的长度,"pwke" 是一个子序列,不是子串。

提示:

  • 0 <= s.length <= 5 * 10^4
  • s 由英文字母、数字、符号和空格组成
cpp 复制代码
class Solution {
public:
    int lengthOfLongestSubstring(string s) {

    }
};

解析代码

研究的对象是一段连续的区间,因此继续使用「滑动窗口」思想来写。

让滑动窗口满足:窗口内所有元素都是不重复的。

做法:右端X元素进入窗口的时候,哈希表统计这个字符的频次:

如果这个字符出现的频次超过1,说明窗口内有重复元素,那么就从左侧开始划出窗口,

直到X这个元素的频次变为1,然后再更新结果。

如果没有超过1, 说明当前窗口没有重复元素,可以直接更新结果。

cpp 复制代码
class Solution {
public:
    int lengthOfLongestSubstring(string s) {
        int hash[128] = { 0 }; // 数组模拟哈希表->s由英文字母、数字、符号和空格组成
        int n =  s.size(), ret = 0, left = 0, right = 0;
        while(right < n)
        {
            hash[s[right]]++; // 进窗口
            while(hash[s[right]] > 1)
            {
                hash[s[left++]]--; // 出窗口->出到和right不在哈希表里
            }
            ret = max(ret, right - left + 1); // 更新结果
            ++right;
        }
        return ret;
    }
};
相关推荐
怕浪猫31 分钟前
Super-agent 在各大模型厂商的应用情况
算法·面试·github
海绵宝宝转agent1 小时前
LeetCode100 二叉树个人题解
算法·leetcode·深度优先
octopus_c1 小时前
C++ 模板详解:函数模板、类模板、特化与分离编译
开发语言·c++·算法
東隅已逝,桑榆非晚1 小时前
算法1. 双指针法-移动零
c++·算法
CQU_JIAKE2 小时前
11.1[A]
算法
文丑颜不良啊2 小时前
LeetCode1581~1600题目解析
java·leetcode
小郎君6582 小时前
(六)el-cascader 的展示值为什么不能直接 join:emitPath、路径还原与多选去重
vue.js·算法
悠仁さん3 小时前
【C++】set map 使用
java·前端·c++
艾莉丝努力练剑3 小时前
【AI大模型接入SDK】ChatServer问题修复
c++·学习·ai·大模型·sdk
扶尔魔ocy3 小时前
【QT C++】常用设计模式
c++·设计模式